//////////////////////////////////////
//	[CPSpinEditBox.h]				//
//	XsGfBbg{bNX`	//
//	ǗNX						//
//	from 2001.10.24					//
//	to   2002.07.19					//
//	Writer : Yoshisaka Yutaka		//
//////////////////////////////////////

#ifndef _CPSPINEDITBOX_H
#define _CPSPINEDITBOX_H

#include "CPGraphics.h"

#include "CPSpin.h"
#include "CPEditBox.h"

class CPSpinEditBox;
typedef void (* LP_SPINEDITBOXPROC)(CPSpinEditBox *);

class LibExport CPSpinEditBox :  public CPGraphics
{
private:
	//̕sȂ߂̋lߕ
	CP_SHLIB_DUMMY512

public:
	CP_SHLIB_DUMMY128

	//----------------------------------------------//
	//	ʂɌJ郁\bh̐錾				//
	//----------------------------------------------//
	CPSpinEditBox();
	~CPSpinEditBox();

	//----- ݒs -----
	void SetBounds(int x,int y,int wid,int hei);	//\ʒuƃTCYw
	void SetSize(int wid,int hei);					//\TCYw
	void SetLocate(int x,int y);					//\ʒuw
	void SetVisible(CP_BOOL f);						//\邩Ȃ

	void SetEnable(CP_BOOL f);							//Lɂ邩ǂiDF\j
	void SetValue(int n);							//lijw
	void SetValueF(double f);						//lijw
	void SetFormat(char *fm);						//\tH[}bgwiftHg"%d"j

	void SetBackgroundColor(unsigned long col);			//wiFw
	void SetForegroundColor(unsigned long col);			//OiFw
	void SetSelectBackgroundColor(unsigned long col);	//I̔wiFw
	void SetSelectForegroundColor(unsigned long col);	//ȊOiFw
	void SetCursorColor(unsigned long col);				//J[\F̎w
	void SetSpinBackgroundColor(unsigned long col);		//Xs{^̔wiFw
	void SetSpinForegroundColor(unsigned long col);		//Xs{^̑OiFw

	//----- J[\̏ ----
	CP_BOOL CursorSelect(int start,int end);			//J[\ɂ͈͑I
	void CursorSelectAll();							//J[\ɂSI
	CP_BOOL CursorPosition(int x);						//J[\ʒuړ

	void SetRange(int min,int max);					//wł鐔lij͈̔͂wiftHg0-100j
	void SetRangeF(double min,double max);			//wł鐔lij͈̔͂w
	void SetDiffValue(int n);						//lij̑lwiftHg1j
	void SetDiffValueF(double n);					//lij̑lw

	void Clear();									//ׂĉ

	//----- 擾s -----
	void GetBounds(CPSTRect *lpRec);				//\ʒuETCY擾
	void GetSize(CPSTSize *lpSize);					//\TCY擾
	void GetLocate(CPSTPosition *lpPos);			//\ʒu擾
	CP_BOOL IsVisible();							//\邩Ȃ

	CP_BOOL IsEnable();								//LEɂ邩ǂ
	int GetValue();									//lij擾
	double GetValueF();								//lij擾
	CP_BOOL GetFormat(char *lpStr,int StrLen);			//\tH[}bg擾
	unsigned long GetBackgroundColor();				//wiF擾
	unsigned long GetForegroundColor();				//OiF擾
	unsigned long GetSelectBackgroundColor();		//I̔wiF擾
	unsigned long GetSelectForegroundColor();		//ȊOiF擾
	unsigned long GetCursorColor();					//J[\F̎擾
	unsigned long GetSpinBackgroundColor();			//Xs{^̔wiF擾
	unsigned long GetSpinForegroundColor();			//Xs{^̑OiF擾

	CP_BOOL GetCursorSelect(int *lpStart,int *lpEnd);	//J[\ł̑I͈͂̎擾
	int GetCursorPosition();							//J[\ʒu̎擾
	CP_BOOL GetRange(int *lpMin,int *lpMax);			//wł鐔lij͈̔͂擾
	CP_BOOL GetRangeF(double *lpMin,double *lpMax);		//wł鐔lij͈̔͂擾
	int GetDiffValue();									//lij̑l擾
	double GetDiffValueF();								//lij̑l擾

	//----- Cxg̑Ή -----
	CP_BOOL AttachFocusEvent(LP_SPINEDITBOXPROC lpProc);			//GfBbg{bNXɃtH[JXꍇ̃Cxg󂯎
	void DetachFocusEvent();						//Cxg̉
	CP_BOOL AttachChangeEvent(LP_SPINEDITBOXPROC lpProc);			//GfBbg{bNX̕񂪕ύXꂽꍇ̃Cxg󂯎
	void DetachChangeEvent();						//Cxg̉
	CP_BOOL AttachUpSelectEvent(LP_SPINEDITBOXPROC lpProc);			//Up{^ꂽꍇ̃Cxg󂯎
	void DetachUpSelectEvent();						//Cxg̉
	CP_BOOL AttachDownSelectEvent(LP_SPINEDITBOXPROC lpProc);		//Down{^ꂽꍇ̃Cxg󂯎
	void DetachDownSelectEvent();					//Cxg̉

	CPWindow *GetParentWindow();	//ẽEBhENX擾
	void Repaint();					//Rg[̍ĕ`s

	//----- c[qg̐p -----
	void SetHintText(char *lpStr);					//c[qg̕wis\j
	void SetHintFontSize(int fSize);				//c[qg̃tHgTCYw
	void SetHintForegroundColor(unsigned long col);	//c[qg̕Fw
	void SetHintBackgroundColor(unsigned long col);	//c[qg̔wiFw

};

#endif
